=== debian/watch ===
version=4
http://archive.ubuntu.com/ubuntu/pool/main/libd/libdbusmenu-qt/libdbusmenu-qt_([0-9+.]+)\.orig\.tar\.(?:bz2|gz|xz)
